var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React, { forwardRef, useMemo, } from "react";
import cn from "classnames";
import { bem } from "@react-md/utils";
import getProgress from "./getProgress";
var block = bem("rmd-circular-progress");
var CircularProgress = function (providedProps) {
    var _a = providedProps, className = _a.className, propSvgStyle = _a.svgStyle, svgClassName = _a.svgClassName, propCircleStyle = _a.circleStyle, circleClassName = _a.circleClassName, value = _a.value, forwardedRef = _a.forwardedRef, min = _a.min, max = _a.max, radius = _a.radius, center = _a.center, viewBox = _a.viewBox, dashoffset = _a.dashoffset, animate = _a.animate, centered = _a.centered, maxRotation = _a.maxRotation, props = __rest(_a, ["className", "svgStyle", "svgClassName", "circleStyle", "circleClassName", "value", "forwardedRef", "min", "max", "radius", "center", "viewBox", "dashoffset", "animate", "centered", "maxRotation"]);
    var progress = getProgress(min, max, value);
    var svgStyle = useMemo(function () {
        if (typeof progress !== "number") {
            return propSvgStyle;
        }
        var transform = propSvgStyle && propSvgStyle.transform;
        if (maxRotation > 0) {
            var rotate = "rotate(" + maxRotation * progress + "deg)";
            transform = "" + rotate + (transform ? " " + transform : "");
        }
        return __assign(__assign({}, propSvgStyle), { WebkitTransform: transform, MozTransform: transform, transform: transform });
    }, [progress, maxRotation, propSvgStyle]);
    var circleStyle = useMemo(function () {
        if (typeof progress !== "number") {
            return propCircleStyle;
        }
        return __assign(__assign({}, propCircleStyle), { strokeDashoffset: dashoffset - dashoffset * progress });
    }, [progress, propCircleStyle, dashoffset]);
    var determinate = typeof progress === "number";
    var indeterminate = !determinate;
    return (React.createElement("span", __assign({}, props, { role: "progressbar", "aria-valuemin": min, "aria-valuemax": max, "aria-valuenow": value, className: cn(block({ centered: centered }), className), ref: forwardedRef }),
        React.createElement("svg", { style: svgStyle, className: cn(block("svg", {
                animate: animate && determinate,
                determinate: determinate,
                indeterminate: indeterminate,
            }), svgClassName), viewBox: viewBox },
            React.createElement("circle", { style: circleStyle, className: cn(block("circle", {
                    animate: animate && determinate,
                    determinate: determinate,
                    indeterminate: indeterminate,
                }), circleClassName), r: radius, cx: center, cy: center }))));
};
var defaultProps = {
    min: 0,
    max: 100,
    dashoffset: 187,
    viewBox: "0 0 66 66",
    radius: 30,
    center: 33,
    animate: true,
    centered: true,
    maxRotation: 360 * 1.75,
};
CircularProgress.defaultProps = defaultProps;
if (process.env.NODE_ENV !== "production") {
    CircularProgress.displayName = "CircularProgress";
    var PropTypes = null;
    try {
        PropTypes = require("prop-types");
    }
    catch (e) { }
    if (PropTypes) {
        CircularProgress.propTypes = {
            id: PropTypes.string.isRequired,
            min: PropTypes.number,
            max: PropTypes.number,
            value: PropTypes.number,
            animate: PropTypes.bool,
            svgStyle: PropTypes.object,
            svgClassName: PropTypes.string,
            circleStyle: PropTypes.object,
            circleClassName: PropTypes.string,
            radius: PropTypes.number,
            center: PropTypes.number,
            centered: PropTypes.bool,
            maxRotation: PropTypes.number,
            dashoffset: PropTypes.number,
            viewBox: PropTypes.string,
        };
    }
}
export default forwardRef(function (props, ref) { return React.createElement(CircularProgress, __assign({}, props, { forwardedRef: ref })); });
//# sourceMappingURL=CircularProgress.js.map